//------------------------------------------/
//											/
//	Mikroprozessortechnik Praktikum 1		/
//	Zusatzaufgabe							/
//	Jrgen Dffinger 						/
//	Version 1.1								/
//	2010-04-08								/
//											/
//------------------------------------------/



// Deklarations for AT90S8515
.INCLUDE "8515def.inc"
.DEF temp = r16	//	working register

//	further definition follow here
.CSEG	//Program-Flash
rjmp start	//	Reset-address
.ORG 0x2A	//	dont program interrupt vector table



/****************   Initialisierung   ***************/

start:
	//	Stack initialisieren
	ldi R16,high(RAMEND)	//	Bits 8..15 laden 
	out sph,R16				//	obere Adresse des Stack initialisieren
	ldi R16,low(RAMEND)		//	Bits 0..7 laden
	out spl, R16			//	untere Adresse des Stack initialisieren
	
	//	Register initialisieren
	ldi R16,0x01			//	Register fr (nicht)setzen vorbereiten

	//	PortC initialisieren
	out DDRC, R16
	
	//	Carry-Flag setzen um Lauflicht zu starten
	sec



/***************   Hauptprogramm   ***************/

main:
	rcall toggle	//	Funktionsaufruf um leuchtende LED zu wechseln
	rcall counter	//	Zhler aufrufen fr 1s Wartezeit
	rjmp main



/***************   Zhler   ***************/

counter:
	//	Register sichern
	push R20
	push R21
	push R22

	//	Register initialisieren 
	ldi R20,0xA3	//	Bits 0..7
	ldi R21,0x13	//	Bits 8..15
	ldi R22,0x06	//	Bits 16..23
	loop:
		dec R20		//	Bits 0..7 dekrementieren
		brne loop	//	Prfen ob Bits 0..7 auf 0x00 stehen
		dec R21		//	Bits 8..15 dekrementieren
		brne loop	//	Prfen ob Bits 8..15 auf 0x00 stehen
		dec R22		//	Bits 16..23 dekrementieren
		brne loop	//	Prfen ob Bits 16..23 auf Null stehen

	//	Register wiederherstellen
	pop R22
	pop R21
	pop R20
	ret					//	Rcksprung wenn Zhler fertig ist (1s)



/***************   toggle   ***************/

toggle:
	push R16		//	Register 16 sichern
	in R16, PORTC	//	Port C in Register 16 sichern
	rol R16			//	left rotate 
	out PORTC, R16	//	Register 16 auf Port C ausgeben
	pop R16			//	Register 16 widerherstellen
	ret				//	Rcksprung


